#include <iostream.h>
#include <new.h>

#include "HeapMax.hh"

#include "HeapMin.hh"

#include "MaxPriorityQueue.hh"

#include "MinPriorityQueue.hh"


int main() {
 // Construction
 MinPriorityQueue<int> h(0,1);
 h.setQueueValue(1024*1024*10);
 int unsortedSeries1[15] = {88,22,44,9,1111,0,33,2,8,14,77,4,112,6,5};
 int root1;
 
 // Insert  unsortedSeries
 cout << "\n\n\n\nBuild Heap:" << "\n-----------" << endl;
 for (int i=0; i<15; i++) {
     h.insertKeyInQueue(unsortedSeries1[i]);
     h.printQueue();
 }
 h.printQueue();

 // Delete key number 1
 h.deleteKey(1);
 h.printQueue();

 // Change key number 6 to value 0
 h.changeKey(6,0);
 h.printQueue();

 // Change key number 7 to value 2222
 h.changeKey(7,2222);
 h.printQueue();
 
 // Change key number 0 to value 3
 // But there is no work because key number 16 is out of 
 // the admissible area
 h.changeKey(0,3);
 h.printQueue();
 
 // Change key number 16 to value 3
 // But there is no work because key number 16 is out of 
 // the admissible area
 h.changeKey(16,3);
 h.printQueue();

 // Extract root until the queue is empty
 cout << "\n\nAnd now the sorted Series: " << endl;
 while (!h.emptyQueue() ) {
     root1 = h.extractRoot();
     cout <<"Root: "<< root1 << ", Heap now: ";
     h.printQueue();
 }
 h.printQueue();

 // Construction
 MaxPriorityQueue<float> f(0.0,6);
 f.setQueueValue(1024*1024*10);
 float unsortedSeries2[11] = {88.0,22.1,44.5,9.7,1111.78,0.0,33.98,2.8,8.6,14.5,7.5};
 float root2;

 // Insert  unsortedSeries
 cout << "\n\n\n\nBuild Heap:" << "\n-----------" << endl;
 for (int i=0; i<11; i++) {
     f.insertKeyInQueue(unsortedSeries2[i]);
     f.printQueue();
 }
 f.printQueue();

 // Delete key number 5
 f.deleteKey(5);
 f.printQueue();

 // Change key number 6 to value 3.4
 f.changeKey(6,3.4);
 f.printQueue();

 // Change key number 7 to value 2222.2
 f.changeKey(7,2222.2);
 f.printQueue();

 // Change key number 0 to value 3.0
 // But there is no work because key number 0 is out of 
 // the admissible area
 f.changeKey(0,3.0);
 f.printQueue();

 // Change key number 16 to value 3.0
 // But there is no work because key number 16 is out of 
 // the admissible area 
 f.changeKey(16,3.0);
 f.printQueue();
 
 // Extract root until the queue is empty
 cout << "\n\nAnd now the sorted Series: " << endl;
 while (!f.emptyQueue() ) {
     root2 = f.extractRoot();
     cout <<"Root: "<< root2 << ", Heap now: ";
     f.printQueue();
 }
 f.printQueue();

 return 0;
}


